<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for atributos StructType
 * @subpackage Structs
 */
class Atributos extends AbstractStructBase
{
    /**
     * The atributo
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Atributo[]
     */
    public $atributo;
    /**
     * Constructor method for atributos
     * @uses Atributos::setAtributo()
     * @param \StructType\Atributo[] $atributo
     */
    public function __construct(array $atributo = array())
    {
        $this
            ->setAtributo($atributo);
    }
    /**
     * Get atributo value
     * @return \StructType\Atributo[]|null
     */
    public function getAtributo()
    {
        return $this->atributo;
    }
    /**
     * This method is responsible for validating the values passed to the setAtributo method
     * This method is willingly generated in order to preserve the one-line inline validation within the setAtributo method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateAtributoForArrayConstraintsFromSetAtributo(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $atributosAtributoItem) {
            // validation for constraint: itemType
            if (!$atributosAtributoItem instanceof \StructType\Atributo) {
                $invalidValues[] = is_object($atributosAtributoItem) ? get_class($atributosAtributoItem) : sprintf('%s(%s)', gettype($atributosAtributoItem), var_export($atributosAtributoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The atributo property can only contain items of type \StructType\Atributo, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set atributo value
     * @throws \InvalidArgumentException
     * @param \StructType\Atributo[] $atributo
     * @return \StructType\Atributos
     */
    public function setAtributo(array $atributo = array())
    {
        // validation for constraint: array
        if ('' !== ($atributoArrayErrorMessage = self::validateAtributoForArrayConstraintsFromSetAtributo($atributo))) {
            throw new \InvalidArgumentException($atributoArrayErrorMessage, __LINE__);
        }
        $this->atributo = $atributo;
        return $this;
    }
    /**
     * Add item to atributo value
     * @throws \InvalidArgumentException
     * @param \StructType\Atributo $item
     * @return \StructType\Atributos
     */
    public function addToAtributo(\StructType\Atributo $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Atributo) {
            throw new \InvalidArgumentException(sprintf('The atributo property can only contain items of type \StructType\Atributo, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->atributo[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Atributos
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
