<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for medios-de-pago StructType
 * @subpackage Structs
 */
class Medios_de_pago extends AbstractStructBase
{
    /**
     * The medio_de_pago
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * @var \StructType\Notificacion_medio_de_pago[]
     */
    public $medio_de_pago;
    /**
     * Constructor method for medios-de-pago
     * @uses Medios_de_pago::setMedio_de_pago()
     * @param \StructType\Notificacion_medio_de_pago[] $medio_de_pago
     */
    public function __construct(array $medio_de_pago = array())
    {
        $this
            ->setMedio_de_pago($medio_de_pago);
    }
    /**
     * Get medio_de_pago value
     * @return \StructType\Notificacion_medio_de_pago[]|null
     */
    public function getMedio_de_pago()
    {
        return $this->{'medio-de-pago'};
    }
    /**
     * This method is responsible for validating the values passed to the setMedio_de_pago method
     * This method is willingly generated in order to preserve the one-line inline validation within the setMedio_de_pago method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateMedio_de_pagoForArrayConstraintsFromSetMedio_de_pago(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $medios_de_pagoMedio_de_pagoItem) {
            // validation for constraint: itemType
            if (!$medios_de_pagoMedio_de_pagoItem instanceof \StructType\Notificacion_medio_de_pago) {
                $invalidValues[] = is_object($medios_de_pagoMedio_de_pagoItem) ? get_class($medios_de_pagoMedio_de_pagoItem) : sprintf('%s(%s)', gettype($medios_de_pagoMedio_de_pagoItem), var_export($medios_de_pagoMedio_de_pagoItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The medio_de_pago property can only contain items of type \StructType\Notificacion_medio_de_pago, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set medio_de_pago value
     * @throws \InvalidArgumentException
     * @param \StructType\Notificacion_medio_de_pago[] $medio_de_pago
     * @return \StructType\Medios_de_pago
     */
    public function setMedio_de_pago(array $medio_de_pago = array())
    {
        // validation for constraint: array
        if ('' !== ($medio_de_pagoArrayErrorMessage = self::validateMedio_de_pagoForArrayConstraintsFromSetMedio_de_pago($medio_de_pago))) {
            throw new \InvalidArgumentException($medio_de_pagoArrayErrorMessage, __LINE__);
        }
        $this->medio_de_pago = $this->{'medio-de-pago'} = $medio_de_pago;
        return $this;
    }
    /**
     * Add item to medio_de_pago value
     * @throws \InvalidArgumentException
     * @param \StructType\Notificacion_medio_de_pago $item
     * @return \StructType\Medios_de_pago
     */
    public function addToMedio_de_pago(\StructType\Notificacion_medio_de_pago $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\Notificacion_medio_de_pago) {
            throw new \InvalidArgumentException(sprintf('The medio_de_pago property can only contain items of type \StructType\Notificacion_medio_de_pago, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->medio_de_pago[] = $this->{'medio-de-pago'}[] = $item;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Medios_de_pago
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
