<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for notificacion-concepto StructType
 * @subpackage Structs
 */
class Notificacion_concepto extends AbstractStructBase
{
    /**
     * The codigo
     * @var string
     */
    public $codigo;
    /**
     * The asume_el_cliente
     * Meta information extracted from the WSDL
     * - default: false
     * @var bool
     */
    public $asume_el_cliente;
    /**
     * The atributos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Atributos
     */
    public $atributos;
    /**
     * The importes_tasas
     * @var \StructType\Importes_tasas
     */
    public $importes_tasas;
    /**
     * Constructor method for notificacion-concepto
     * @uses Notificacion_concepto::setCodigo()
     * @uses Notificacion_concepto::setAsume_el_cliente()
     * @uses Notificacion_concepto::setAtributos()
     * @uses Notificacion_concepto::setImportes_tasas()
     * @param string $codigo
     * @param bool $asume_el_cliente
     * @param \StructType\Atributos $atributos
     * @param \StructType\Importes_tasas $importes_tasas
     */
    public function __construct($codigo = null, $asume_el_cliente = false, \StructType\Atributos $atributos = null, \StructType\Importes_tasas $importes_tasas = null)
    {
        $this
            ->setCodigo($codigo)
            ->setAsume_el_cliente($asume_el_cliente)
            ->setAtributos($atributos)
            ->setImportes_tasas($importes_tasas);
    }
    /**
     * Get codigo value
     * @return string|null
     */
    public function getCodigo()
    {
        return $this->codigo;
    }
    /**
     * Set codigo value
     * @param string $codigo
     * @return \StructType\Notificacion_concepto
     */
    public function setCodigo($codigo = null)
    {
        // validation for constraint: string
        if (!is_null($codigo) && !is_string($codigo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo, true), gettype($codigo)), __LINE__);
        }
        $this->codigo = $codigo;
        return $this;
    }
    /**
     * Get asume_el_cliente value
     * @return bool|null
     */
    public function getAsume_el_cliente()
    {
        return $this->{'asume-el-cliente'};
    }
    /**
     * Set asume_el_cliente value
     * @param bool $asume_el_cliente
     * @return \StructType\Notificacion_concepto
     */
    public function setAsume_el_cliente($asume_el_cliente = false)
    {
        // validation for constraint: boolean
        if (!is_null($asume_el_cliente) && !is_bool($asume_el_cliente)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a bool, %s given', var_export($asume_el_cliente, true), gettype($asume_el_cliente)), __LINE__);
        }
        $this->asume_el_cliente = $this->{'asume-el-cliente'} = $asume_el_cliente;
        return $this;
    }
    /**
     * Get atributos value
     * @return \StructType\Atributos|null
     */
    public function getAtributos()
    {
        return $this->atributos;
    }
    /**
     * Set atributos value
     * @param \StructType\Atributos $atributos
     * @return \StructType\Notificacion_concepto
     */
    public function setAtributos(\StructType\Atributos $atributos = null)
    {
        $this->atributos = $atributos;
        return $this;
    }
    /**
     * Get importes_tasas value
     * @return \StructType\Importes_tasas|null
     */
    public function getImportes_tasas()
    {
        return $this->{'importes-tasas'};
    }
    /**
     * Set importes_tasas value
     * @param \StructType\Importes_tasas $importes_tasas
     * @return \StructType\Notificacion_concepto
     */
    public function setImportes_tasas(\StructType\Importes_tasas $importes_tasas = null)
    {
        $this->importes_tasas = $this->{'importes-tasas'} = $importes_tasas;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Notificacion_concepto
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
