<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for notificacion-transaccion StructType
 * @subpackage Structs
 */
class Notificacion_transaccion extends AbstractStructBase
{
    /**
     * The codigo_autorizacion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codigo_autorizacion;
    /**
     * The id_externo
     * @var string
     */
    public $id_externo;
    /**
     * The codigo_comercio
     * @var string
     */
    public $codigo_comercio;
    /**
     * The estado_transaccion
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $estado_transaccion;
    /**
     * The tipo_notificacion
     * @var string
     */
    public $tipo_notificacion;
    /**
     * The codigo_respuesta
     * @var string
     */
    public $codigo_respuesta;
    /**
     * The mensaje
     * @var string
     */
    public $mensaje;
    /**
     * The canal_de_pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $canal_de_pago;
    /**
     * The codigo_moneda
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codigo_moneda;
    /**
     * The referencia_de_cobro
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $referencia_de_cobro;
    /**
     * The fecha_hora_actual
     * @var string
     */
    public $fecha_hora_actual;
    /**
     * The codigo_autorizacion_mp
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codigo_autorizacion_mp;
    /**
     * The productos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Productos
     */
    public $productos;
    /**
     * The medios_de_pago
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Medios_de_pago
     */
    public $medios_de_pago;
    /**
     * The atributos
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var \StructType\Atributos
     */
    public $atributos;
    /**
     * The codigo_barras_b64
     * Meta information extracted from the WSDL
     * - minOccurs: 0
     * @var string
     */
    public $codigo_barras_b64;
    /**
     * Constructor method for notificacion-transaccion
     * @uses Notificacion_transaccion::setCodigo_autorizacion()
     * @uses Notificacion_transaccion::setId_externo()
     * @uses Notificacion_transaccion::setCodigo_comercio()
     * @uses Notificacion_transaccion::setEstado_transaccion()
     * @uses Notificacion_transaccion::setTipo_notificacion()
     * @uses Notificacion_transaccion::setCodigo_respuesta()
     * @uses Notificacion_transaccion::setMensaje()
     * @uses Notificacion_transaccion::setCanal_de_pago()
     * @uses Notificacion_transaccion::setCodigo_moneda()
     * @uses Notificacion_transaccion::setReferencia_de_cobro()
     * @uses Notificacion_transaccion::setFecha_hora_actual()
     * @uses Notificacion_transaccion::setCodigo_autorizacion_mp()
     * @uses Notificacion_transaccion::setProductos()
     * @uses Notificacion_transaccion::setMedios_de_pago()
     * @uses Notificacion_transaccion::setAtributos()
     * @uses Notificacion_transaccion::setCodigo_barras_b64()
     * @param string $codigo_autorizacion
     * @param string $id_externo
     * @param string $codigo_comercio
     * @param string $estado_transaccion
     * @param string $tipo_notificacion
     * @param string $codigo_respuesta
     * @param string $mensaje
     * @param string $canal_de_pago
     * @param string $codigo_moneda
     * @param string $referencia_de_cobro
     * @param string $fecha_hora_actual
     * @param string $codigo_autorizacion_mp
     * @param \StructType\Productos $productos
     * @param \StructType\Medios_de_pago $medios_de_pago
     * @param \StructType\Atributos $atributos
     * @param string $codigo_barras_b64
     */
    public function __construct($codigo_autorizacion = null, $id_externo = null, $codigo_comercio = null, $estado_transaccion = null, $tipo_notificacion = null, $codigo_respuesta = null, $mensaje = null, $canal_de_pago = null, $codigo_moneda = null, $referencia_de_cobro = null, $fecha_hora_actual = null, $codigo_autorizacion_mp = null, \StructType\Productos $productos = null, \StructType\Medios_de_pago $medios_de_pago = null, \StructType\Atributos $atributos = null, $codigo_barras_b64 = null)
    {
        $this
            ->setCodigo_autorizacion($codigo_autorizacion)
            ->setId_externo($id_externo)
            ->setCodigo_comercio($codigo_comercio)
            ->setEstado_transaccion($estado_transaccion)
            ->setTipo_notificacion($tipo_notificacion)
            ->setCodigo_respuesta($codigo_respuesta)
            ->setMensaje($mensaje)
            ->setCanal_de_pago($canal_de_pago)
            ->setCodigo_moneda($codigo_moneda)
            ->setReferencia_de_cobro($referencia_de_cobro)
            ->setFecha_hora_actual($fecha_hora_actual)
            ->setCodigo_autorizacion_mp($codigo_autorizacion_mp)
            ->setProductos($productos)
            ->setMedios_de_pago($medios_de_pago)
            ->setAtributos($atributos)
            ->setCodigo_barras_b64($codigo_barras_b64);
    }
    /**
     * Get codigo_autorizacion value
     * @return string|null
     */
    public function getCodigo_autorizacion()
    {
        return $this->{'codigo-autorizacion'};
    }
    /**
     * Set codigo_autorizacion value
     * @param string $codigo_autorizacion
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_autorizacion($codigo_autorizacion = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_autorizacion) && !is_string($codigo_autorizacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_autorizacion, true), gettype($codigo_autorizacion)), __LINE__);
        }
        $this->codigo_autorizacion = $this->{'codigo-autorizacion'} = $codigo_autorizacion;
        return $this;
    }
    /**
     * Get id_externo value
     * @return string|null
     */
    public function getId_externo()
    {
        return $this->{'id-externo'};
    }
    /**
     * Set id_externo value
     * @param string $id_externo
     * @return \StructType\Notificacion_transaccion
     */
    public function setId_externo($id_externo = null)
    {
        // validation for constraint: string
        if (!is_null($id_externo) && !is_string($id_externo)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($id_externo, true), gettype($id_externo)), __LINE__);
        }
        $this->id_externo = $this->{'id-externo'} = $id_externo;
        return $this;
    }
    /**
     * Get codigo_comercio value
     * @return string|null
     */
    public function getCodigo_comercio()
    {
        return $this->{'codigo-comercio'};
    }
    /**
     * Set codigo_comercio value
     * @param string $codigo_comercio
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_comercio($codigo_comercio = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_comercio) && !is_string($codigo_comercio)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_comercio, true), gettype($codigo_comercio)), __LINE__);
        }
        $this->codigo_comercio = $this->{'codigo-comercio'} = $codigo_comercio;
        return $this;
    }
    /**
     * Get estado_transaccion value
     * @return string|null
     */
    public function getEstado_transaccion()
    {
        return $this->{'estado-transaccion'};
    }
    /**
     * Set estado_transaccion value
     * @uses \EnumType\Estado_transaccion::valueIsValid()
     * @uses \EnumType\Estado_transaccion::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $estado_transaccion
     * @return \StructType\Notificacion_transaccion
     */
    public function setEstado_transaccion($estado_transaccion = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\Estado_transaccion::valueIsValid($estado_transaccion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\Estado_transaccion', is_array($estado_transaccion) ? implode(', ', $estado_transaccion) : var_export($estado_transaccion, true), implode(', ', \EnumType\Estado_transaccion::getValidValues())), __LINE__);
        }
        $this->estado_transaccion = $this->{'estado-transaccion'} = $estado_transaccion;
        return $this;
    }
    /**
     * Get tipo_notificacion value
     * @return string|null
     */
    public function getTipo_notificacion()
    {
        return $this->{'tipo-notificacion'};
    }
    /**
     * Set tipo_notificacion value
     * @uses \EnumType\TipoNotificacion::valueIsValid()
     * @uses \EnumType\TipoNotificacion::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $tipo_notificacion
     * @return \StructType\Notificacion_transaccion
     */
    public function setTipo_notificacion($tipo_notificacion = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\TipoNotificacion::valueIsValid($tipo_notificacion)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\TipoNotificacion', is_array($tipo_notificacion) ? implode(', ', $tipo_notificacion) : var_export($tipo_notificacion, true), implode(', ', \EnumType\TipoNotificacion::getValidValues())), __LINE__);
        }
        $this->tipo_notificacion = $this->{'tipo-notificacion'} = $tipo_notificacion;
        return $this;
    }
    /**
     * Get codigo_respuesta value
     * @return string|null
     */
    public function getCodigo_respuesta()
    {
        return $this->{'codigo-respuesta'};
    }
    /**
     * Set codigo_respuesta value
     * @param string $codigo_respuesta
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_respuesta($codigo_respuesta = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_respuesta) && !is_string($codigo_respuesta)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_respuesta, true), gettype($codigo_respuesta)), __LINE__);
        }
        $this->codigo_respuesta = $this->{'codigo-respuesta'} = $codigo_respuesta;
        return $this;
    }
    /**
     * Get mensaje value
     * @return string|null
     */
    public function getMensaje()
    {
        return $this->mensaje;
    }
    /**
     * Set mensaje value
     * @param string $mensaje
     * @return \StructType\Notificacion_transaccion
     */
    public function setMensaje($mensaje = null)
    {
        // validation for constraint: string
        if (!is_null($mensaje) && !is_string($mensaje)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($mensaje, true), gettype($mensaje)), __LINE__);
        }
        $this->mensaje = $mensaje;
        return $this;
    }
    /**
     * Get canal_de_pago value
     * @return string|null
     */
    public function getCanal_de_pago()
    {
        return $this->{'canal-de-pago'};
    }
    /**
     * Set canal_de_pago value
     * @param string $canal_de_pago
     * @return \StructType\Notificacion_transaccion
     */
    public function setCanal_de_pago($canal_de_pago = null)
    {
        // validation for constraint: string
        if (!is_null($canal_de_pago) && !is_string($canal_de_pago)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($canal_de_pago, true), gettype($canal_de_pago)), __LINE__);
        }
        $this->canal_de_pago = $this->{'canal-de-pago'} = $canal_de_pago;
        return $this;
    }
    /**
     * Get codigo_moneda value
     * @return string|null
     */
    public function getCodigo_moneda()
    {
        return $this->{'codigo-moneda'};
    }
    /**
     * Set codigo_moneda value
     * @param string $codigo_moneda
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_moneda($codigo_moneda = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_moneda) && !is_string($codigo_moneda)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_moneda, true), gettype($codigo_moneda)), __LINE__);
        }
        $this->codigo_moneda = $this->{'codigo-moneda'} = $codigo_moneda;
        return $this;
    }
    /**
     * Get referencia_de_cobro value
     * @return string|null
     */
    public function getReferencia_de_cobro()
    {
        return $this->{'referencia-de-cobro'};
    }
    /**
     * Set referencia_de_cobro value
     * @param string $referencia_de_cobro
     * @return \StructType\Notificacion_transaccion
     */
    public function setReferencia_de_cobro($referencia_de_cobro = null)
    {
        // validation for constraint: string
        if (!is_null($referencia_de_cobro) && !is_string($referencia_de_cobro)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($referencia_de_cobro, true), gettype($referencia_de_cobro)), __LINE__);
        }
        $this->referencia_de_cobro = $this->{'referencia-de-cobro'} = $referencia_de_cobro;
        return $this;
    }
    /**
     * Get fecha_hora_actual value
     * @return string|null
     */
    public function getFecha_hora_actual()
    {
        return $this->{'fecha-hora-actual'};
    }
    /**
     * Set fecha_hora_actual value
     * @param string $fecha_hora_actual
     * @return \StructType\Notificacion_transaccion
     */
    public function setFecha_hora_actual($fecha_hora_actual = null)
    {
        // validation for constraint: string
        if (!is_null($fecha_hora_actual) && !is_string($fecha_hora_actual)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($fecha_hora_actual, true), gettype($fecha_hora_actual)), __LINE__);
        }
        $this->fecha_hora_actual = $this->{'fecha-hora-actual'} = $fecha_hora_actual;
        return $this;
    }
    /**
     * Get codigo_autorizacion_mp value
     * @return string|null
     */
    public function getCodigo_autorizacion_mp()
    {
        return $this->{'codigo-autorizacion-mp'};
    }
    /**
     * Set codigo_autorizacion_mp value
     * @param string $codigo_autorizacion_mp
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_autorizacion_mp($codigo_autorizacion_mp = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_autorizacion_mp) && !is_string($codigo_autorizacion_mp)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_autorizacion_mp, true), gettype($codigo_autorizacion_mp)), __LINE__);
        }
        $this->codigo_autorizacion_mp = $this->{'codigo-autorizacion-mp'} = $codigo_autorizacion_mp;
        return $this;
    }
    /**
     * Get productos value
     * @return \StructType\Productos|null
     */
    public function getProductos()
    {
        return $this->productos;
    }
    /**
     * Set productos value
     * @param \StructType\Productos $productos
     * @return \StructType\Notificacion_transaccion
     */
    public function setProductos(\StructType\Productos $productos = null)
    {
        $this->productos = $productos;
        return $this;
    }
    /**
     * Get medios_de_pago value
     * @return \StructType\Medios_de_pago|null
     */
    public function getMedios_de_pago()
    {
        return $this->{'medios-de-pago'};
    }
    /**
     * Set medios_de_pago value
     * @param \StructType\Medios_de_pago $medios_de_pago
     * @return \StructType\Notificacion_transaccion
     */
    public function setMedios_de_pago(\StructType\Medios_de_pago $medios_de_pago = null)
    {
        $this->medios_de_pago = $this->{'medios-de-pago'} = $medios_de_pago;
        return $this;
    }
    /**
     * Get atributos value
     * @return \StructType\Atributos|null
     */
    public function getAtributos()
    {
        return $this->atributos;
    }
    /**
     * Set atributos value
     * @param \StructType\Atributos $atributos
     * @return \StructType\Notificacion_transaccion
     */
    public function setAtributos(\StructType\Atributos $atributos = null)
    {
        $this->atributos = $atributos;
        return $this;
    }
    /**
     * Get codigo_barras_b64 value
     * @return string|null
     */
    public function getCodigo_barras_b64()
    {
        return $this->{'codigo-barras-b64'};
    }
    /**
     * Set codigo_barras_b64 value
     * @param string $codigo_barras_b64
     * @return \StructType\Notificacion_transaccion
     */
    public function setCodigo_barras_b64($codigo_barras_b64 = null)
    {
        // validation for constraint: string
        if (!is_null($codigo_barras_b64) && !is_string($codigo_barras_b64)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($codigo_barras_b64, true), gettype($codigo_barras_b64)), __LINE__);
        }
        $this->codigo_barras_b64 = $this->{'codigo-barras-b64'} = $codigo_barras_b64;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Notificacion_transaccion
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
